summaryrefslogtreecommitdiffstats
path: root/zsh/oh-my-zsh/plugins/nvm
diff options
context:
space:
mode:
authorLibravatarLibravatar Biswakalyan Bhuyan <biswa@surgot.in> 2022-10-03 21:42:20 +0530
committerLibravatarLibravatar Biswakalyan Bhuyan <biswa@surgot.in> 2022-10-03 21:42:20 +0530
commitaf120ab348f2e1a5a39dec035ed9dcf84189a64e (patch)
tree2a3aadd7ce1b7b771dfe3fe7c983569726c8d7ed /zsh/oh-my-zsh/plugins/nvm
downloaddotfiles-af120ab348f2e1a5a39dec035ed9dcf84189a64e.tar.gz
dotfiles-af120ab348f2e1a5a39dec035ed9dcf84189a64e.tar.bz2
dotfiles-af120ab348f2e1a5a39dec035ed9dcf84189a64e.zip
dotfiles
Diffstat (limited to 'zsh/oh-my-zsh/plugins/nvm')
-rw-r--r--zsh/oh-my-zsh/plugins/nvm/README.md34
-rw-r--r--zsh/oh-my-zsh/plugins/nvm/_nvm34
-rw-r--r--zsh/oh-my-zsh/plugins/nvm/nvm.plugin.zsh79
3 files changed, 147 insertions, 0 deletions
diff --git a/zsh/oh-my-zsh/plugins/nvm/README.md b/zsh/oh-my-zsh/plugins/nvm/README.md
new file mode 100644
index 0000000..a8bc34a
--- /dev/null
+++ b/zsh/oh-my-zsh/plugins/nvm/README.md
@@ -0,0 +1,34 @@
+# nvm plugin
+
+This plugin adds autocompletions for [nvm](https://github.com/nvm-sh/nvm) — a Node.js version manager.
+It also automatically sources nvm, so you don't need to do it manually in your `.zshrc`.
+
+To use it, add `nvm` to the plugins array of your zshrc file:
+
+```zsh
+plugins=(... nvm)
+```
+
+## Settings
+
+If you installed nvm in a directory other than `$HOME/.nvm`, set and export `NVM_DIR` to be the directory
+where you installed nvm.
+
+These settings should go in your zshrc file, before Oh My Zsh is sourced:
+
+- **`NVM_HOMEBREW`**: if you installed nvm via Homebrew, in a directory other than `/usr/local/opt/nvm`, you
+ can set `NVM_HOMEBREW` to be the directory where you installed it. For example, on Apple Silicon-based Macs,
+ [Homebrew is installed in `/opt/homebrew`](https://docs.brew.sh/Installation). To get the directory where
+ nvm has been installed, regardless of chip architecture, use `NVM_HOMEBREW=$(brew --prefix nvm)`.
+
+- **`NVM_LAZY`**: if you want the plugin to defer the load of nvm to speed-up the start of your zsh session,
+ set `NVM_LAZY` to `1`. This will use the `--no-use` parameter when loading nvm, and will create a function
+ for `node`, `npm`, `yarn`, and the command(s) specified by `NVM_LAZY_CMD`, so when you call either of them,
+ nvm will load with `nvm use default`.
+
+- **`NVM_LAZY_CMD`**: if you want additional command(s) to trigger lazy loading of nvm, set `NVM_LAZY_CMD` to
+ the command or an array of the commands.
+
+- **`NVM_AUTOLOAD`**: if `NVM_AUTOLOAD` is set to `1`, the plugin will automatically load a node version when
+ if finds a [`.nvmrc` file](https://github.com/nvm-sh/nvm#nvmrc) in the current working directory indicating
+ which node version to load.
diff --git a/zsh/oh-my-zsh/plugins/nvm/_nvm b/zsh/oh-my-zsh/plugins/nvm/_nvm
new file mode 100644
index 0000000..e292a8d
--- /dev/null
+++ b/zsh/oh-my-zsh/plugins/nvm/_nvm
@@ -0,0 +1,34 @@
+#compdef nvm
+#autoload
+
+[[ -f "$NVM_DIR/nvm.sh" ]] || return 0
+
+local -a _1st_arguments
+_1st_arguments=(
+ 'help:show help'
+ '--version:print out the latest released version of nvm'
+ 'install:download and install a version in <node|iojs|node version number>'
+ 'install-latest-npm:download and install the latest npm version'
+ 'uninstall:uninstall a version'
+ 'use:modify PATH to use <version>. Uses .nvmrc if available'
+ 'exec:run <command> on <version>. Uses .nvmrc if available'
+ 'run:run `node` on <version> with <args> as arguments. Uses .nvmrc if available'
+ 'current:list installed versions'
+ 'ls:list installed versions or versions matching a given description'
+ 'version:resolve the given description to a single local version'
+ 'version-remote:resolve the given description to a single remote version'
+ 'ls-remote:list remote versions available for install'
+ 'deactivate:undo effects of `nvm` on current shell'
+ 'alias:show or set aliases'
+ 'unalias:deletes an alias'
+ 'reinstall-packages:reinstall global `npm` packages contained in <version> to current version'
+ 'unload:unload `nvm` from shell'
+ 'which:display path to installed node version. Uses .nvmrc if available'
+)
+
+_arguments -C '*:: :->subcmds' && return 0
+
+if (( CURRENT == 1 )); then
+ _describe -t commands "nvm subcommand" _1st_arguments
+ return
+fi
diff --git a/zsh/oh-my-zsh/plugins/nvm/nvm.plugin.zsh b/zsh/oh-my-zsh/plugins/nvm/nvm.plugin.zsh
new file mode 100644
index 0000000..630854a
--- /dev/null
+++ b/zsh/oh-my-zsh/plugins/nvm/nvm.plugin.zsh
@@ -0,0 +1,79 @@
+# See https://github.com/nvm-sh/nvm#installation-and-update
+if [[ -z "$NVM_DIR" ]]; then
+ if [[ -d "$HOME/.nvm" ]]; then
+ export NVM_DIR="$HOME/.nvm"
+ elif [[ -d "${XDG_CONFIG_HOME:-$HOME/.config}/nvm" ]]; then
+ export NVM_DIR="${XDG_CONFIG_HOME:-$HOME/.config}/nvm"
+ fi
+fi
+
+# Don't try to load nvm if command already available
+# Note: nvm is a function so we need to use `which`
+! which nvm &>/dev/null || return
+
+if [[ -f "$NVM_DIR/nvm.sh" ]]; then
+ # Load nvm if it exists in $NVM_DIR
+ source "$NVM_DIR/nvm.sh" ${NVM_LAZY+"--no-use"}
+elif (( $+commands[brew] )); then
+ # Otherwise try to load nvm installed via Homebrew
+ # User can set this if they have an unusual Homebrew setup
+ NVM_HOMEBREW="${NVM_HOMEBREW:-${HOMEBREW_PREFIX:-$(brew --prefix)}/opt/nvm}"
+ # Load nvm from Homebrew location if it exists
+ if [[ -f "$NVM_HOMEBREW/nvm.sh" ]]; then
+ source "$NVM_HOMEBREW/nvm.sh" ${NVM_LAZY+"--no-use"}
+ else
+ return
+ fi
+else
+ return
+fi
+
+# Call nvm when first using node, npm or yarn
+if (( $+NVM_LAZY )); then
+ function node npm yarn $NVM_LAZY_CMD {
+ unfunction node npm yarn $NVM_LAZY_CMD
+ nvm use default
+ command "$0" "$@"
+ }
+fi
+
+# Autoload nvm when finding a .nvmrc file in the current directory
+# Adapted from: https://github.com/nvm-sh/nvm#zsh
+if (( $+NVM_AUTOLOAD )); then
+ load-nvmrc() {
+ local node_version="$(nvm version)"
+ local nvmrc_path="$(nvm_find_nvmrc)"
+
+ if [[ -n "$nvmrc_path" ]]; then
+ local nvmrc_node_version=$(nvm version "$(cat "${nvmrc_path}")")
+
+ if [[ "$nvmrc_node_version" = "N/A" ]]; then
+ nvm install
+ elif [[ "$nvmrc_node_version" != "$node_version" ]]; then
+ nvm use
+ fi
+ elif [[ "$node_version" != "$(nvm version default)" ]]; then
+ echo "Reverting to nvm default version"
+ nvm use default
+ fi
+ }
+
+ autoload -U add-zsh-hook
+ add-zsh-hook chpwd load-nvmrc
+
+ load-nvmrc
+fi
+
+# Load nvm bash completion
+for nvm_completion in "$NVM_DIR/bash_completion" "$NVM_HOMEBREW/etc/bash_completion.d/nvm"; do
+ if [[ -f "$nvm_completion" ]]; then
+ # Load bashcompinit
+ autoload -U +X bashcompinit && bashcompinit
+ # Bypass compinit call in nvm bash completion script. See:
+ # https://github.com/nvm-sh/nvm/blob/4436638/bash_completion#L86-L93
+ ZSH_VERSION= source "$nvm_completion"
+ break
+ fi
+done
+
+unset NVM_HOMEBREW NVM_LAZY NVM_AUTOLOAD nvm_completion